package com.loafle.overflow.module.email.service;

import com.loafle.overflow.module.email.dao.EmailAuthDAO;
import com.loafle.overflow.module.email.model.EmailAuth;
import com.loafle.overflow.module.member.model.Member;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.FileSystemResource;
import org.springframework.mail.MailException;
import org.springframework.mail.SimpleMailMessage;
import org.springframework.mail.javamail.JavaMailSender;
import org.springframework.mail.javamail.MimeMessageHelper;
import org.springframework.stereotype.Service;

import javax.mail.MessagingException;
import javax.mail.internet.MimeMessage;
import java.io.File;
import java.util.List;

/**
 * Created by geek on 17. 6. 28.
 */
@Service("EmailAuthService")
public class EmailAuthService {

    @Autowired
    private JavaMailSender mailSender;

    @Autowired
    private EmailAuthDAO emailAuthDAO;

    public EmailAuth sendEmailByMember(long memberId, String memberEmail) {
        try {
            this.sendSimpleEmail(memberEmail, "Confirm Email", "Confirm Email");
        }catch (MailException e) {
            e.printStackTrace();
        }

        EmailAuth auth = new EmailAuth();
        auth.setMember(new Member(memberId));
        // Todo AuthKey Generation
        auth.setEmailAuthKey("djdjdjdjeiejdikdjki");

        this.emailAuthDAO.save(auth);

        return auth;
    }

    public EmailAuth read(long id) {
        return this.emailAuthDAO.findOne(id);
    }

    public EmailAuth readByAuthKey(String authKey) {
        return this.emailAuthDAO.findByEmailAuthKey(authKey);
    }

    public List<EmailAuth> readByMember(long memberId) {
        return this.emailAuthDAO.findByMember(new Member(memberId));
    }

    public EmailAuth modify(EmailAuth emailAuth) {
        return this.emailAuthDAO.save(emailAuth);
    }

    private void sendSimpleEmail(String to, String sub, String message) throws MailException {

        SimpleMailMessage message1 = new SimpleMailMessage();
        message1.setTo(to);
        message1.setSubject(sub);
        message1.setText(message);
        message1.setFrom("geek@loafle.com");

        mailSender.send(message1);
    }

    private void sendMailWithAttachment(String to, String sub, String text, String path) throws MessagingException {
        MimeMessage message = mailSender.createMimeMessage();
        // pass 'true' to the constructor to create a multipart message
        MimeMessageHelper helper = new MimeMessageHelper(message, true);

        helper.setTo(to);
        helper.setSubject(sub);
        helper.setText(text);
        helper.setFrom("geek@loafle.com");
        FileSystemResource file = new FileSystemResource(new File(path));
        helper.addAttachment("Invoice", file);

        mailSender.send(message);
    }
}
