package com.loafle.overflow.module.infra.service;

import com.loafle.overflow.module.infra.model.InfraOS;
import com.loafle.overflow.module.infra.model.InfraOSDaemon;
import com.loafle.overflow.module.meta.model.MetaInfraType;
import com.loafle.overflow.spring.AppConfigTest;
import org.codehaus.jackson.map.ObjectMapper;
import org.junit.Assert;
import org.junit.Ignore;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringJUnit4ClassRunner;

import static org.junit.Assert.*;

/**
 * Created by snoop on 17. 7. 28.
 */
@RunWith(SpringJUnit4ClassRunner.class)
@ContextConfiguration(classes = {AppConfigTest.class})
public class InfraOSDaemonServiceTest {

    @Autowired
    private InfraOSDaemonService infraOSDaemonService;

//    @Ignore
    @Test
    public void regist() throws Exception {

        InfraOSDaemon infraOSDaemon = new InfraOSDaemon();
        infraOSDaemon.setName("Apache");

        InfraOS infraOS = new InfraOS();
        infraOS.setId(2);

        infraOSDaemon.setOs(infraOS);

        MetaInfraType metaInfraType = new MetaInfraType();
        metaInfraType.setId(5);

        infraOSDaemon.setInfraType(metaInfraType);

        this.infraOSDaemonService.regist(infraOSDaemon);

        Assert.assertNotEquals(infraOSDaemon.getId(), 0);

    }

    @Test
    public void read() throws Exception {

        InfraOSDaemon infraOSDaemon = this.infraOSDaemonService.read(1);
        Assert.assertNotNull(infraOSDaemon);

        ObjectMapper objectMapper = new ObjectMapper();
        String json = objectMapper.writeValueAsString(infraOSDaemon);
        System.out.println(json);

    }

}